<template>
  <div>
    <div class="d-flex justify-content-end mb-3">
      <button class="btn btn-success mr-3" @click.prevent="loadTerdampak">
        Load Item
      </button>

      <template v-if="isReady">
        <template v-if="isLoadUpdate">
          <button class="btn btn-primary mr-3">
            <b-spinner
              variant="light"
              style="width: 1rem; height: 1rem;"
              label="Spinning"
            ></b-spinner>
          </button>
        </template>
        <template v-else>
          <button class="btn btn-primary mr-3" @click.prevent="save">
            Simpan Change Management Item
          </button>
        </template>
      </template>
      <template v-else>
        <button class="btn btn-primary mr-3" disabled>
          Simpan Change Management Item
        </button>
      </template>

      <template>
        <button
          class="text-white font-weight-bold mr-3 btn btn-primary"
          v-b-modal.modal-xl
        >
          <i class="flaticon2-plus"></i>
        </button>
      </template>

      <button
        class="btn btn-secondary"
        style="border-top-right-radius: 0; border-bottom-right-radius: 0;"
      >
        <i class="flaticon-search"></i>
      </button>
      <input
        type="text"
        class="form-control w-25"
        style="border-top-left-radius: 0; border-bottom-left-radius: 0;"
      />
    </div>

    <div class="table-responsive">
      <table
        class="table table-head-custom table-vertical-center table-head-bg table-borderless"
      >
        <thead>
          <th style="min-width: 100px;">Numbering</th>
          <th style="min-width: 100px;">Title</th>
          <th style="min-width: 100px;">Type</th>
          <th style="min-width: 100px;">Category</th>
          <th style="min-width: 100px;">Scope</th>
          <th style="min-width: 100px;">Stasiun</th>
          <th style="min-width: 100px;">Plan Date</th>
          <th style="min-width: 200px;" class="text-center">Aksi</th>
        </thead>
        <template v-if="this.$store.getters.getterDesignTerdampak.length == 0">
          <tbody>
            <tr v-if="isLoad">
              <td colspan="8" class="text-center">
                <b-spinner variant="primary" label="Spinning"></b-spinner>
              </td>
            </tr>
            <tr v-else>
              <td colspan="8" class="text-center">
                <div class="text-center">
                  <i class="flaticon2-open-box text-secondary icon-3x"></i>

                  <h4>
                    Data kosong.
                  </h4>
                </div>
              </td>
            </tr>
          </tbody>
        </template>
        <template v-else>
          <template
            v-for="(item, i) in this.$store.getters.getterDesignTerdampak"
          >
            <tbody v-bind:key="i">
              <tr>
                <td>{{ item.dld.numbering }}</td>
                <td>{{ item.dld.title }}</td>
                <td>
                  {{ item.dld.type_code == "" ? "-" : item.dld.type.name }}
                </td>
                <td>
                  {{
                    item.dld.category_code == null
                      ? "-"
                      : item.dld.category_code
                  }}
                </td>
                <td>
                  {{ item.dld.scope_code == null ? "-" : item.dld.scope.name }}
                </td>
                <td>
                  {{ item.dld.station == null ? "-" : item.dld.station.name }}
                </td>
                <td>
                  <template>
                    <div v-bind:class="'d-none edit-form-terdampak-' + i">
                      <input
                        type="date"
                        class="form-control"
                        v-model="add.date"
                      />
                    </div>
                    <div v-bind:class="'edit-text-terdampak-' + i">
                      {{
                        item.dld.planning_date == null
                          ? "-"
                          : item.dld.planning_date
                      }}
                    </div>
                  </template>
                </td>
                <td class="text-center">
                  <template>
                    <div v-bind:id="'action-terdampak-' + i">
                      <a
                        class="btn btn-light-success font-weight-bolder font-size-sm"
                        @click.prevent="editTerdampak(item, i)"
                      >
                        <i class="flaticon-edit"></i>
                      </a>
                      <a
                        class="btn btn-light-danger font-weight-bolder font-size-sm"
                        @click="openDialogDelete(item)"
                      >
                        <i class="flaticon-delete"></i>
                      </a>
                    </div>
                    <div
                      class="d-none"
                      v-bind:id="'action-cancel-terdampak-' + i"
                    >
                      <a
                        class="btn btn-light-danger font-weight-bolder font-size-sm"
                        @click.prevent="cancelTerdampak(i)"
                      >
                        <i class="flaticon2-cross"></i>
                      </a>
                    </div>
                  </template>
                </td>
              </tr>
            </tbody>
          </template>
        </template>
      </table>
    </div>

    <!-- modal -->
    <b-modal
      id="modal-xl"
      no-close-on-backdrop="true"
      footer-class="d-none"
      scrollable
      size="xl"
      title="Extra Large Modal"
    >
      <add-design-terdampak></add-design-terdampak>
    </b-modal>

    <v-app
      v-bind:class="{
        'd-none': isModalDelete
      }"
    >
      <v-dialog
        v-model="dialog"
        transition="dialog-top-transition"
        max-width="400"
      >
        <v-card>
          <v-card-title class="headline">Konfirmasi Hapus Data</v-card-title>

          <v-card-text>
            Apakah anda yakin ingin menghapus data
            <b>
              {{
                this.currentDelete == null
                  ? "ini"
                  : "'" + this.currentDelete + "'"
              }}
            </b>
            ?
          </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn color="green darken-1" text @click="deleteDesign()">
              Hapus
            </v-btn>

            <v-btn color="green darken-1" text @click="closeDialog">
              Batal
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-app>
  </div>
</template>

<script>
import AddDesignTerdampak from "./AddDesignTerdampak";
import {
  GET_DESIGN_TERDAMPAK,
  UPDATE_DESIGN_TERDAMPAK,
  DELETE_DESIGN_TERDAMPAK,
  RESET_DESIGN_TERDAMPAK
} from "@/core/services/store/change-management.module";

export default {
  name: "DesignTerdampak",
  components: {
    AddDesignTerdampak
  },
  data() {
    return {
      data: {
        design: [
          {
            numbering: "GEN-F08-002100",
            title: "PDPS",
            type: "Document",
            category: "External-T",
            scope: "HMI",
            station: "TAN"
          },
          {
            numbering: "GEN-F08-002100",
            title: "PDPS",
            type: "Document",
            category: "External-T",
            scope: "HMI",
            station: "TAN"
          }
        ]
      },
      add: {
        date: "",
        idDld: "",
        idChange: ""
      },
      isLoad: false,
      isReady: false,
      isAdd: false,
      isInput: false,
      isLoadUpdate: false,
      dialog: false,
      isModalDelete: true,
      currentDelete: null,
      currentDeleteId: null,
      currentEdit: null
    };
  },
  methods: {
    editTerdampak(item, x) {
      if (this.isInput == true) {
        this.$bvToast.toast("Selesaikan form edit terlebih dahulu", {
          title: "Warning",
          variant: "danger",
          solid: true
        });
      } else {
        var input = document.getElementsByClassName("edit-form-terdampak-" + x);
        var text = document.getElementsByClassName("edit-text-terdampak-" + x);
        var action = document.getElementById("action-terdampak-" + x);
        var cancel = document.getElementById("action-cancel-terdampak-" + x);

        for (var i = 0; i < input.length; i++) {
          input[i].classList.remove("d-none");
          text[i].classList.add("d-none");
        }

        var idDld = item.dld.id;
        var idChange = item.id;

        action.classList.add("d-none");
        cancel.classList.remove("d-none");
        this.isReady = true;
        this.add.idDld = idDld;
        this.add.idChange = idChange;
        this.currentEdit = x;
        this.isInput = true;
      }
    },
    cancelTerdampak(id) {
      var input = document.getElementsByClassName("edit-form-terdampak-" + id);
      var text = document.getElementsByClassName("edit-text-terdampak-" + id);
      var action = document.getElementById("action-terdampak-" + id);
      var cancel = document.getElementById("action-cancel-terdampak-" + id);

      for (var i = 0; i < input.length; i++) {
        input[i].classList.add("d-none");
        text[i].classList.remove("d-none");
      }

      action.classList.remove("d-none");
      cancel.classList.add("d-none");
      this.isReady = false;
      this.currentEdit = null;
      this.add.idChange = "";
      this.add.idDld = "";
      this.isInput = false;
    },
    async loadTerdampak() {
      this.isLoad = true;
      await this.$store.dispatch(GET_DESIGN_TERDAMPAK, {
        id: this.$route.params.id_change_management
      });
      this.isLoad = false;
      this.isAdd = true;
    },
    async save() {
      if (this.add.date == "") {
        this.$bvToast.toast("Tanggal harus diisi.", {
          title: "Warning",
          variant: "danger",
          solid: true
        });
      } else {
        var date = this.add.date;
        var split = date.split("-");
        var fix = split[2] + "-" + split[1] + "-" + split[0];
        var id = this.add.idChange;
        var idDld = this.add.idDld;
        var send = [
          {
            id: id,
            dld: {
              id: idDld,
              planning_date: fix
            }
          }
        ];

        var data = { dld: send };
        this.isLoadUpdate = true;
        await this.$store.dispatch(UPDATE_DESIGN_TERDAMPAK, {
          send: data,
          id: this.$route.params.id_change_management
        });

        this.isLoadUpdate = false;

        // load
        this.loadTerdampak();
        this.cancelTerdampak(this.currentEdit);

        if (this.$store.getters.getterUpdateDesignTerdampak.length > 0) {
          this.$bvToast.toast("Data berhasil di edit.", {
            title: "Success",
            variant: "success",
            solid: true
          });
        } else {
          this.$bvToast.toast("Terjadi kesalahan.", {
            title: "Warning",
            variant: "danger",
            solid: true
          });
        }
      }
    },
    openDialogDelete(item) {
      this.dialog = true;
      this.isModalDelete = false;
      this.currentDelete = item.dld.title;
      this.currentDeleteId = item.id;
    },
    closeDialog() {
      this.dialog = false;
      this.isModalDelete = true;
      this.currentDelete = null;
      this.currentDeleteId = null;
    },
    async deleteDesign() {
      this.dialog = false;
      this.isModalDelete = true;
      var id = this.currentDeleteId;
      await this.$store.dispatch(DELETE_DESIGN_TERDAMPAK, { id: id });
      this.$bvToast.toast("Data berhasil dihapus", {
        title: "Success",
        variant: "success",
        solid: true
      });
      this.loadTerdampak();
    }
  },
  mounted() {
    this.$root.$on("bv::modal::show", () => {
      this.$store.dispatch(RESET_DESIGN_TERDAMPAK);
    });
  }
};
</script>
